| AAX SDK 2.8.0 Avid Audio Extensions Development Kit

- Welcome
- Manual
- Classes
- Files
- Lists
- Support

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
List of all members | Public Member Functions
AAX_IParameter Class Referenceabstract
AAX SDK Manual » AAX Library features » Parameter Manager

`#include <AAX_IParameter.h>`

Inheritance diagram for AAX_IParameter:
[legend]

## Description

The base interface for all normalizable plug-in parameters.

:Internal to the AAX SDK:

This class is an outside interface for an arbitrarily typed parameter. The subclasses of this generic interface hold the parameter's state and conversion functionality.

Note
  This class is not part of the AAX ABI and must not be passed between the plug-in and the host. Version checking is recommended when passing references to this interface between plug-in modules (e.g. between the data model and the GUI)

## Public Member Functions
virtual | ~AAX_IParameter ()
| Virtual destructor.
virtual AAX_IParameterValue * | CloneValue () const =0
| Clone the parameter's value to a new AAX_IParameterValue object.
Identification methods
virtual AAX_CParamID | Identifier () const =0
| Returns the parameter's unique identifier.
virtual void | SetName (const AAX_CString &name)=0
| Sets the parameter's display name.
virtual const AAX_CString & | Name () const =0
| Returns the parameter's display name.
virtual void | AddShortenedName (const AAX_CString &name)=0
| Sets the parameter's shortened display name.
virtual const AAX_CString & | ShortenedName (int32_t iNumCharacters) const =0
| Returns the parameter's shortened display name.
virtual void | ClearShortenedNames ()=0
| Clears the internal list of shortened display names.
Automation methods
virtual bool | Automatable () const =0
| Returns true if the parameter is automatable, false if it is not.
virtual void | SetAutomationDelegate (AAX_IAutomationDelegate *iAutomationDelegate)=0
| Sets the automation delegate (if one is required)
virtual void | Touch ()=0
| Signals the automation system that a control has been touched.
virtual void | Release ()=0
| Signals the automation system that a control has been released.
Taper methods
virtual void | SetNormalizedValue (double newNormalizedValue)=0
| Sets a parameter value using it's normalized representation.
virtual double | GetNormalizedValue () const =0
| Returns the normalized representation of the parameter's current real value.
virtual void | SetNormalizedDefaultValue (double normalizedDefault)=0
| Sets the parameter's default value using its normalized representation.
virtual double | GetNormalizedDefaultValue () const =0
| Returns the normalized representation of the parameter's real default value.
virtual void | SetToDefaultValue ()=0
| Restores the state of this parameter to its default value.
virtual void | SetNumberOfSteps (uint32_t numSteps)=0
| Sets the number of discrete steps for this parameter.
virtual uint32_t | GetNumberOfSteps () const =0
| Returns the number of discrete steps used by the parameter.
virtual uint32_t | GetStepValue () const =0
| Returns the current step for the current value of the parameter.
virtual double | GetNormalizedValueFromStep (uint32_t iStep) const =0
| Returns the normalized value for a given step.
virtual uint32_t | GetStepValueFromNormalizedValue (double normalizedValue) const =0
| Returns the step value for a normalized value of the parameter.
virtual void | SetStepValue (uint32_t iStep)=0
| Returns the current step for the current value of the parameter.
Display methods
This functionality is most often used by GUIs, but can also be useful for state serialization.
virtual bool | GetValueString (AAX_CString *valueString) const =0
| Serializes the parameter value into a string.
virtual bool | GetValueString (int32_t iMaxNumChars, AAX_CString *valueString) const =0
| Serializes the parameter value into a string, size hint included.
virtual bool | GetNormalizedValueFromBool (bool value, double *normalizedValue) const =0
| Converts a bool to a normalized parameter value.
virtual bool | GetNormalizedValueFromInt32 (int32_t value, double *normalizedValue) const =0
| Converts an integer to a normalized parameter value.
virtual bool | GetNormalizedValueFromFloat (float value, double *normalizedValue) const =0
| Converts a float to a normalized parameter value.
virtual bool | GetNormalizedValueFromDouble (double value, double *normalizedValue) const =0
| Converts a double to a normalized parameter value.
virtual bool | GetNormalizedValueFromString (const AAX_CString &valueString, double *normalizedValue) const =0
| Converts a given string to a normalized parameter value.
virtual bool | GetBoolFromNormalizedValue (double normalizedValue, bool *value) const =0
| Converts a normalized parameter value to a bool representing the corresponding real value.
virtual bool | GetInt32FromNormalizedValue (double normalizedValue, int32_t *value) const =0
| Converts a normalized parameter value to an integer representing the corresponding real value.
virtual bool | GetFloatFromNormalizedValue (double normalizedValue, float *value) const =0
| Converts a normalized parameter value to a float representing the corresponding real value.
virtual bool | GetDoubleFromNormalizedValue (double normalizedValue, double *value) const =0
| Converts a normalized parameter value to a double representing the corresponding real value.
virtual bool | GetStringFromNormalizedValue (double normalizedValue, AAX_CString &valueString) const =0
| Converts a normalized parameter value to a string representing the corresponding real value.
virtual bool | GetStringFromNormalizedValue (double normalizedValue, int32_t iMaxNumChars, AAX_CString &valueString) const =0
| Converts a normalized parameter value to a string representing the corresponding real, size hint included. value.
virtual bool | SetValueFromString (const AAX_CString &newValueString)=0
| Converts a string to a real parameter value and sets the parameter to this value.
Typed accessors
virtual bool | GetValueAsBool (bool *value) const =0
| Retrieves the parameter's value as a bool.
virtual bool | GetValueAsInt32 (int32_t *value) const =0
| Retrieves the parameter's value as an int32_t.
virtual bool | GetValueAsFloat (float *value) const =0
| Retrieves the parameter's value as a float.
virtual bool | GetValueAsDouble (double *value) const =0
| Retrieves the parameter's value as a double.
virtual bool | GetValueAsString (AAX_IString *value) const =0
| Retrieves the parameter's value as a string.
virtual bool | SetValueWithBool (bool value)=0
| Sets the parameter's value as a bool.
virtual bool | SetValueWithInt32 (int32_t value)=0
| Sets the parameter's value as an int32_t.
virtual bool | SetValueWithFloat (float value)=0
| Sets the parameter's value as a float.
virtual bool | SetValueWithDouble (double value)=0
| Sets the parameter's value as a double.
virtual bool | SetValueWithString (const AAX_IString &value)=0
| Sets the parameter's value as a string.
virtual void | SetType (AAX_EParameterType iControlType)=0
| Sets the type of this parameter.
virtual AAX_EParameterType | GetType () const =0
| Returns the type of this parameter as an AAX_EParameterType.
virtual void | SetOrientation (AAX_EParameterOrientation iOrientation)=0
| Sets the orientation of this parameter.
virtual AAX_EParameterOrientation | GetOrientation () const =0
| Returns the orientation of this parameter.
virtual void | SetTaperDelegate (AAX_ITaperDelegateBase &inTaperDelegate, bool inPreserveValue)=0
| Sets the parameter's taper delegate.
virtual void | SetDisplayDelegate (AAX_IDisplayDelegateBase &inDisplayDelegate)=0
| Sets the parameter's display delegate.
Host interface methods
virtual void | UpdateNormalizedValue (double newNormalizedValue)=0
| Sets the parameter's state given a normalized value.

## Constructor & Destructor Documentation

## ◆ ~AAX_IParameter()

virtual AAX_IParameter::~AAX_IParameter | ( |  | ) |
| inline virtual

Virtual destructor.

Note
  This destructor MUST be virtual to prevent memory leaks.

## Member Function Documentation

## ◆ CloneValue()

virtual AAX_IParameterValue * AAX_IParameter::CloneValue | ( |  | ) | const
| pure virtual

Clone the parameter's value to a new AAX_IParameterValue object.

The returned object is independent from the AAX_IParameter. For example, changing the state of the returned object will not result in a change to the original AAX_IParameter.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

Referenced by AAX_CMonolithicParameters::GenerateCoefficients().

Here is the caller graph for this function:

## ◆ Identifier()

virtual AAX_CParamID AAX_IParameter::Identifier | ( |  | ) | const
| pure virtual

Returns the parameter's unique identifier.

This unique ID is used by the Parameter Manager and by outside applications to uniquely identify and target control messages. This value may not be changed after the parameter has been constructed.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

Referenced by AAX_CMonolithicParameters::AddSynchronizedParameter(), and AAX_CMonolithicParameters::GenerateCoefficients().

Here is the caller graph for this function:

## ◆ SetName()

virtual void AAX_IParameter::SetName | ( | const AAX_CString & | name | ) |
| pure virtual

Sets the parameter's display name.

This name is used for display only, it is not used for indexing or identifying the parameter This name may be changed after the parameter has been created, but display name changes may not be recognized by all AAX hosts.

Parameters

  [in] | name | Display name that will be assigned to the parameter

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ Name()

virtual const AAX_CString & AAX_IParameter::Name | ( |  | ) | const
| pure virtual

Returns the parameter's display name.

Note
  This method returns a const reference in order to prevent a string copy. Do not cast away the const to change this value.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ AddShortenedName()

virtual void AAX_IParameter::AddShortenedName | ( | const AAX_CString & | name | ) |
| pure virtual

Sets the parameter's shortened display name.

This name is used for display only, it is not used for indexing or identifying the parameter These names show up when the host asks for shorter length parameter names for display on Control Surfaces or other string length constrained situations.

Parameters

  [in] | name | Shortened display names that will be assigned to the parameter

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ ShortenedName()

virtual const AAX_CString & AAX_IParameter::ShortenedName | ( | int32_t | iNumCharacters | ) | const
| pure virtual

Returns the parameter's shortened display name.

Note
  This method returns a const reference in order to prevent a string copy. Do not cast away the const to change this value.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ ClearShortenedNames()

virtual void AAX_IParameter::ClearShortenedNames | ( |  | ) |
| pure virtual

Clears the internal list of shortened display names.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ Automatable()

virtual bool AAX_IParameter::Automatable | ( |  | ) | const
| pure virtual

Returns true if the parameter is automatable, false if it is not.

Note
  Subclasses that return true in this method must support host-based automation.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

Referenced by AAX_CMonolithicParameters::AddSynchronizedParameter().

Here is the caller graph for this function:

## ◆ SetAutomationDelegate()

virtual void AAX_IParameter::SetAutomationDelegate | ( | AAX_IAutomationDelegate * | iAutomationDelegate | ) |
| pure virtual

Sets the automation delegate (if one is required)

Parameters

  [in] | iAutomationDelegate | A reference to the parameter manager's automation delegate interface

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ Touch()

virtual void AAX_IParameter::Touch | ( |  | ) |
| pure virtual

Signals the automation system that a control has been touched.

Call this method in response to GUI events that begin editing, such as a mouse down. After this method has been called you are free to call SetNormalizedValue() as much as you need, e.g. in order to respond to subsequent mouse moved events. Call Release() to free the parameter for updates from other controls.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ Release()

virtual void AAX_IParameter::Release | ( |  | ) |
| pure virtual

Signals the automation system that a control has been released.

Call this method in response to GUI events that complete editing, such as a mouse up. Once this method has been called you should not call SetNormalizedValue() again until after the next call to Touch().

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetNormalizedValue()

virtual void AAX_IParameter::SetNormalizedValue | ( | double | newNormalizedValue | ) |
| pure virtual

Sets a parameter value using it's normalized representation.

For more information regarding normalized values, see Parameter Manager

Parameters

  [in] | newNormalizedValue | New value (normalized) to which the parameter will be set

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNormalizedValue()

virtual double AAX_IParameter::GetNormalizedValue | ( |  | ) | const
| pure virtual

Returns the normalized representation of the parameter's current real value.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetNormalizedDefaultValue()

virtual void AAX_IParameter::SetNormalizedDefaultValue | ( | double | normalizedDefault | ) |
| pure virtual

Sets the parameter's default value using its normalized representation.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNormalizedDefaultValue()

virtual double AAX_IParameter::GetNormalizedDefaultValue | ( |  | ) | const
| pure virtual

Returns the normalized representation of the parameter's real default value.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetToDefaultValue()

virtual void AAX_IParameter::SetToDefaultValue | ( |  | ) |
| pure virtual

Restores the state of this parameter to its default value.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetNumberOfSteps()

virtual void AAX_IParameter::SetNumberOfSteps | ( | uint32_t | numSteps | ) |
| pure virtual

Sets the number of discrete steps for this parameter.

Stepped parameter values are useful for discrete parameters and for "jumping" events such as mouse wheels, page up/down, etc. The parameter's step size is used to specify the coarseness of those changes.

Note
  numSteps MUST be greater than zero. All other values may be considered an error by the host.

Parameters

  [in] | numSteps | The number of steps that the parameter will use

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNumberOfSteps()

virtual uint32_t AAX_IParameter::GetNumberOfSteps | ( |  | ) | const
| pure virtual

Returns the number of discrete steps used by the parameter.

See SetNumberOfSteps() for more information about parameter steps.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetStepValue()

virtual uint32_t AAX_IParameter::GetStepValue | ( |  | ) | const
| pure virtual

Returns the current step for the current value of the parameter.

See SetNumberOfSteps() for more information about parameter steps.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNormalizedValueFromStep()

virtual double AAX_IParameter::GetNormalizedValueFromStep | ( | uint32_t | iStep | ) | const
| pure virtual

Returns the normalized value for a given step.

See SetNumberOfSteps() for more information about parameter steps.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetStepValueFromNormalizedValue()

virtual uint32_t AAX_IParameter::GetStepValueFromNormalizedValue | ( | double | normalizedValue | ) | const
| pure virtual

Returns the step value for a normalized value of the parameter.

See SetNumberOfSteps() for more information about parameter steps.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetStepValue()

virtual void AAX_IParameter::SetStepValue | ( | uint32_t | iStep | ) |
| pure virtual

Returns the current step for the current value of the parameter.

See SetNumberOfSteps() for more information about parameter steps.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetValueString() [1/2]

virtual bool AAX_IParameter::GetValueString | ( | AAX_CString * | valueString | ) | const
| pure virtual

Serializes the parameter value into a string.

Parameters

  [out] | valueString | A string representing the parameter's real value

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetValueString() [2/2]

virtual bool AAX_IParameter::GetValueString | ( | int32_t | iMaxNumChars,
|  | AAX_CString * | valueString
| ) |  | const
| pure virtual

Serializes the parameter value into a string, size hint included.

Parameters

  [in] | iMaxNumChars | A size hint for the size of the string being requested. Useful for control surfaces and other limited area text fields. (make sure that size of desired string also has room for null termination)
  [out] | valueString | A string representing the parameter's real value

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNormalizedValueFromBool()

virtual bool AAX_IParameter::GetNormalizedValueFromBool | ( | bool | value,
|  | double * | normalizedValue
| ) |  | const
| pure virtual

Converts a bool to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNormalizedValueFromInt32()

virtual bool AAX_IParameter::GetNormalizedValueFromInt32 | ( | int32_t | value,
|  | double * | normalizedValue
| ) |  | const
| pure virtual

Converts an integer to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNormalizedValueFromFloat()

virtual bool AAX_IParameter::GetNormalizedValueFromFloat | ( | float | value,
|  | double * | normalizedValue
| ) |  | const
| pure virtual

Converts a float to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNormalizedValueFromDouble()

virtual bool AAX_IParameter::GetNormalizedValueFromDouble | ( | double | value,
|  | double * | normalizedValue
| ) |  | const
| pure virtual

Converts a double to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetNormalizedValueFromString()

virtual bool AAX_IParameter::GetNormalizedValueFromString | ( | const AAX_CString & | valueString,
|  | double * | normalizedValue
| ) |  | const
| pure virtual

Converts a given string to a normalized parameter value.

Parameters

  [in] | valueString | A string representing a possible real value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with valueString

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implemented in AAX_CStatelessParameter, and AAX_CParameter< T >.

## ◆ GetBoolFromNormalizedValue()

virtual bool AAX_IParameter::GetBoolFromNormalizedValue | ( | double | normalizedValue,
|  | bool * | value
| ) |  | const
| pure virtual

Converts a normalized parameter value to a bool representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to bool was successful
  false | The conversion to bool was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetInt32FromNormalizedValue()

virtual bool AAX_IParameter::GetInt32FromNormalizedValue | ( | double | normalizedValue,
|  | int32_t * | value
| ) |  | const
| pure virtual

Converts a normalized parameter value to an integer representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to int32_t was successful
  false | The conversion to int32_t was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetFloatFromNormalizedValue()

virtual bool AAX_IParameter::GetFloatFromNormalizedValue | ( | double | normalizedValue,
|  | float * | value
| ) |  | const
| pure virtual

Converts a normalized parameter value to a float representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to float was successful
  false | The conversion to float was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetDoubleFromNormalizedValue()

virtual bool AAX_IParameter::GetDoubleFromNormalizedValue | ( | double | normalizedValue,
|  | double * | value
| ) |  | const
| pure virtual

Converts a normalized parameter value to a double representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to double was successful
  false | The conversion to double was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetStringFromNormalizedValue() [1/2]

virtual bool AAX_IParameter::GetStringFromNormalizedValue | ( | double | normalizedValue,
|  | AAX_CString & | valueString
| ) |  | const
| pure virtual

Converts a normalized parameter value to a string representing the corresponding real value.

Parameters

  [in] | normalizedValue | A normalized parameter value
  [out] | valueString | A string representing the parameter value associated with normalizedValue

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetStringFromNormalizedValue() [2/2]

virtual bool AAX_IParameter::GetStringFromNormalizedValue | ( | double | normalizedValue,
|  | int32_t | iMaxNumChars,
|  | AAX_CString & | valueString
| ) |  | const
| pure virtual

Converts a normalized parameter value to a string representing the corresponding real, size hint included. value.

Parameters

  [in] | normalizedValue | A normalized parameter value
  [in] | iMaxNumChars | A size hint for the size of the string being requested. Useful for control surfaces and other limited area text fields. (make sure that size of desired string also has room for null termination)
  [out] | valueString | A string representing the parameter value associated with normalizedValue

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetValueFromString()

virtual bool AAX_IParameter::SetValueFromString | ( | const AAX_CString & | newValueString | ) |
| pure virtual

Converts a string to a real parameter value and sets the parameter to this value.

Parameters

  [in] | newValueString | A string representing the parameter's new real value

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetValueAsBool()

virtual bool AAX_IParameter::GetValueAsBool | ( | bool * | value | ) | const
| pure virtual

Retrieves the parameter's value as a bool.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to bool was successful
  false | The conversion to bool was unsuccessful

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetValueAsInt32()

virtual bool AAX_IParameter::GetValueAsInt32 | ( | int32_t * | value | ) | const
| pure virtual

Retrieves the parameter's value as an int32_t.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to int32_t was successful
  false | The conversion to int32_t was unsuccessful

Implemented in AAX_CStatelessParameter, and AAX_CParameter< T >.

## ◆ GetValueAsFloat()

virtual bool AAX_IParameter::GetValueAsFloat | ( | float * | value | ) | const
| pure virtual

Retrieves the parameter's value as a float.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to float was successful
  false | The conversion to float was unsuccessful

Implemented in AAX_CStatelessParameter, and AAX_CParameter< T >.

## ◆ GetValueAsDouble()

virtual bool AAX_IParameter::GetValueAsDouble | ( | double * | value | ) | const
| pure virtual

Retrieves the parameter's value as a double.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to double was successful
  false | The conversion to double was unsuccessful

Implemented in AAX_CStatelessParameter, and AAX_CParameter< T >.

## ◆ GetValueAsString()

virtual bool AAX_IParameter::GetValueAsString | ( | AAX_IString * | value | ) | const
| pure virtual

Retrieves the parameter's value as a string.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to string was successful
  false | The conversion to string was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CStatelessParameter, and AAX_CParameter< T >.

## ◆ SetValueWithBool()

virtual bool AAX_IParameter::SetValueWithBool | ( | bool | value | ) |
| pure virtual

Sets the parameter's value as a bool.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from bool was successful
  false | The conversion from bool was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetValueWithInt32()

virtual bool AAX_IParameter::SetValueWithInt32 | ( | int32_t | value | ) |
| pure virtual

Sets the parameter's value as an int32_t.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from int32_t was successful
  false | The conversion from int32_t was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetValueWithFloat()

virtual bool AAX_IParameter::SetValueWithFloat | ( | float | value | ) |
| pure virtual

Sets the parameter's value as a float.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from float was successful
  false | The conversion from float was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetValueWithDouble()

virtual bool AAX_IParameter::SetValueWithDouble | ( | double | value | ) |
| pure virtual

Sets the parameter's value as a double.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from double was successful
  false | The conversion from double was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetValueWithString()

virtual bool AAX_IParameter::SetValueWithString | ( | const AAX_IString & | value | ) |
| pure virtual

Sets the parameter's value as a string.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from string was successful
  false | The conversion from string was unsuccessful

Implemented in AAX_CParameter< T >, AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetType()

virtual void AAX_IParameter::SetType | ( | AAX_EParameterType | iControlType | ) |
| pure virtual

Sets the type of this parameter.

See GetType for use cases

Parameters

  [in] | iControlType | The parameter's new type as an AAX_EParameterType

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetType()

virtual AAX_EParameterType AAX_IParameter::GetType | ( |  | ) | const
| pure virtual

Returns the type of this parameter as an AAX_EParameterType.

Todo:
  Document use cases for control type

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetOrientation()

virtual void AAX_IParameter::SetOrientation | ( | AAX_EParameterOrientation | iOrientation | ) |
| pure virtual

Sets the orientation of this parameter.

Parameters

  [in] | iOrientation | The parameter's new orientation

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ GetOrientation()

virtual AAX_EParameterOrientation AAX_IParameter::GetOrientation | ( |  | ) | const
| pure virtual

Returns the orientation of this parameter.

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

## ◆ SetTaperDelegate()

virtual void AAX_IParameter::SetTaperDelegate | ( | AAX_ITaperDelegateBase & | inTaperDelegate,
|  | bool | inPreserveValue
| ) |  |
| pure virtual

Sets the parameter's taper delegate.

Parameters

  [in] | inTaperDelegate | A reference to the parameter's new taper delegate
  [in] | inPreserveValue |

Todo:
  Document this parameter

Implemented in AAX_CStatelessParameter, and AAX_CParameter< T >.

## ◆ SetDisplayDelegate()

virtual void AAX_IParameter::SetDisplayDelegate | ( | AAX_IDisplayDelegateBase & | inDisplayDelegate | ) |
| pure virtual

Sets the parameter's display delegate.

Parameters

  [in] | inDisplayDelegate | A reference to the parameter's new display delegate

Implemented in AAX_CStatelessParameter, and AAX_CParameter< T >.

## ◆ UpdateNormalizedValue()

virtual void AAX_IParameter::UpdateNormalizedValue | ( | double | newNormalizedValue | ) |
| pure virtual

Sets the parameter's state given a normalized value.

This is the second half of the parameter setting operation that is initiated with a call to SetValue(). Parameters should not be set directly using this method; instead, use SetValue().

Parameters

  [in] | newNormalizedValue | Normalized value that will be used to set the parameter's new state

Implemented in AAX_CParameter< T >, and AAX_CStatelessParameter.

The documentation for this class was generated from the following file:

- AAX_IParameter.h